/*======================================================================*/
/* Q&A card R.1 Gaku Nakagawa                                               */
/*======================================================================*/

#include "psdos.h"
#include "lcdbios.h"
#include "wbios.h"
#include "rupsys.h"
#include "font.h"
#include "rupmenu.h"
#include "softkey.h"

/* ݏdefine	*/
#define Key_file		0x0001		/*	swA(K0)荞	*/
#define Key_enter		0x0008		/*	swB(K3)荞	*/
#define Key_el			0x0004		/*	swC(K2)荞	*/
#define Key_menu		0x0002		/*	swD(K1)荞	*/
#define Key_left		0x0010		/*	swE(K4)荞	*/
#define Key_up			0x0020		/*	swF(K5)荞	*/
#define Key_right		0x0040		/*	swG(K6)荞	*/
#define Key_down		0x0080		/*	swH(K7)荞	*/
/* ʐMG[R[h */
#define	BLDSTOP			-4	/* drW݂o			*/
#define	TIMEOUTerr		-5	/* ѱ						*/
#define BSIZE	30000
#define MAX		2000
#define INI		"\\SYSTEM\\INI\\QA.INI"
#define UCHAR	unsigned char
#define UINT	unsigned int

int disp_mes(char *s,int y);
int spnum(char *buf, int n, int j);
int setting(void);
void load_file(void);
void qa_exit(int x);
int folder(void);

static WatchDT Time;
static const RECT CLRLCD={0,0,101,63};
static MENU menuLIST[]={
	{ setExitMenu,	"ع݂̏I@ ",0,0},
	{ setting,		"ݒ@@@@@@@",0,0},
	{ setBackMenu,	"߂@@@@@@@",0,0}

};
UCHAR jis2=0xff,qas=0,shuffle=0,oldsh,qa=0;
UINT max,max2,file=1,oldfile=0,p,seed,fp0=-1,write=0;
UINT index[MAX],six[MAX];
UCHAR buf[BSIZE],work[32];

/*-----------------------------------------------------------*/
/*	 v\iPbj	      							 */
/*-----------------------------------------------------------*/
void dispWATCH(int All)
{
	int chgHour;
	char s[9];
	Time = *pSystemCtl->CPUram;
	/* RAM̎ԃf[^ǂݍ 				*/
	/* getRTC();葁Aȓd́Aȃ[	*/

	s[0]='0'+(Time.NOW_Hour)/10;
	s[1]='0'+(Time.NOW_Hour)%10;
	s[2]=s[5]=':';
	s[3]='0'+(Time.NOW_Min)/10;
	s[4]='0'+(Time.NOW_Min)%10;
	s[6]='0'+(Time.NOW_Sec)/10;
	s[7]='0'+(Time.NOW_Sec)%10;
	s[8]=0;
	gv_kput(46,51,s,32,0,0);

	spnum(s,Time.NOW_Year,4);
	s[4]=0;
	gv_kput(28,52,s,8,1,0);
	dispNowDate(24, 58, 8, 1, 1);/* t	*/
}

int disp_mes(char *s,int y)
{
	char c,s1[18],buf[256];
	int x=0,xx,p,pos,size,os,line;
	buf[0]=12;
	buf[2]=12;
	buf[1]=buf[3]=0;

	for(line=0;line<2;line++) {
		xx=p=pos=0;
		while(s[x]>0x0d && xx<16) {
			c=s[x];
			if(c<0x81 || (c>=0xa0 && c<=0xdf)) {	/* ANK */
				s1[p++]=c;
				x++;
				xx++;
			}
			else {
				if(c>jis2 || c==jis2 && s[x+1]>=0x9f) {	/* jis2 0xff:0x98 */
					s1[p]=0;
					gv_kput(pos,y,s1,0,0,0);

					if(c>=0xe0) {
						c-=(0xe0-8);
					}
					else {
						c-=0x98;
					}
					os=(c*188)-94;
					c=s[x+1];
					if(c<0x80) {
						c-=0x40;
					}
					else {
						c-=(0x80-63);
					}
					os+=c;

					if(fp0==-1) {
						fp0=dos_open("JIS2FONT.DAT",0);
					}
					if(fp0!=-1) {
						dos_seek(fp0,0,(long)os*24);
						size=dos_read(fp0,&buf[4],24);
					}
					gv_put(xx*6,y, buf, 0) ;
					p=0;
					x+=2;
					xx+=2;
					pos=xx*6;
				}
				else {
					s1[p++]=c;
					x++;
					s1[p++]=s[x++];
					xx+=2;
				}
			}
		}
		s1[p]=0;
		gv_kput(pos,y,s1,0,0,0);
		y+=12;
	}
}

int spnum(char *buf, int n, int x)
{
	int i,dec=1;

	for(i=1; i<x; i++) {
		dec *=10;
	}
	for(i=0; i<x; i++) {
		if(n>=dec || dec==1) {
			buf[i]=((n/dec)%10)+'0';
			n -=n/dec*dec;
		}
		else {
			buf[i]='0';
		}
		dec /=10;
	}
	return(x);
}

void load_file(void)
{
	UCHAR c,*s="001.QA";
	int fp1,size=0,p,r,sw;

	dos_chdir(work);

	if(file!=oldfile) {
		oldfile=file;
		spnum(s,file,3);
		fp1=dos_open(s,0);
		if(fp1!=-1) {
			size=dos_read(fp1,buf,BSIZE-1);
			if(dos_close(fp1)!=0 || size<0) {
				qa_exit(0);
			}
		}
		p=max=six[0]=index[0]=0;
		buf[size]=0x0a;

		while(max<MAX && p<size) {
			c=buf[p];
			if(c>=0x20 && c!='#' && c!='\'') {
				index[max++]=p;
			}
			do {
				c=buf[p++];
			} while(c!=0x0d && c!=0x0a);
		}
		max2=max;
		oldsh=-1;
	}
	if(shuffle!=oldsh) {
		for(p=0;p<max;p++) {
			six[p]=p;
		}
		if(shuffle) {
			srand(seed);
			for(p=0;p<max;p++) {
				r=rand()%max;
				sw=six[p];
				six[p]=six[r];
				six[r]=sw;
			}
		}
		oldsh=shuffle;
	}
}

int folder(void)
{
	STRSTS ctrl = { picFOLDA ,ALPHA_U_TYPE, HAN_SZ,0,0,0,31};
	UINT i;

	if(softkey(&ctrl,work,0,0)==-1) {
		qa_exit(0);
	}
	for(i=0;i<32;i++) {
		if(work[i]=='/') {
			work[i]='\\';
		}
	}
	return(0);
}

/*   entryItemMenup   j[s֐ */
int setting(void)
{
	int id,ret;
	UINT fp1;
	UCHAR *s="001.QA";

	static char TITLES[][9]={
		{" ̧  "},
		{"  "},
		{" o  "},
		{" o  "},
		{" JIS2  "},
		{" ̫ "},
	};
	static const char num_menu[][5] = {
		{" 100"},
		{"  99"},
		{"  98"},
		{"  97"},
		{"  96"},
		{"  95"},
		{"  94"},
		{"  93"},
		{"  92"},
		{"  91"},
		{"  90"},
		{"  89"},
		{"  88"},
		{"  87"},
		{"  86"},
		{"  85"},
		{"  84"},
		{"  83"},
		{"  82"},
		{"  81"},
		{"  80"},
		{"  79"},
		{"  78"},
		{"  77"},
		{"  76"},
		{"  75"},
		{"  74"},
		{"  73"},
		{"  72"},
		{"  71"},
		{"  70"},
		{"  69"},
		{"  68"},
		{"  67"},
		{"  66"},
		{"  65"},
		{"  64"},
		{"  63"},
		{"  62"},
		{"  61"},
		{"  60"},
		{"  59"},
		{"  58"},
		{"  57"},
		{"  56"},
		{"  55"},
		{"  54"},
		{"  53"},
		{"  52"},
		{"  51"},
		{"  50"},
		{"  49"},
		{"  48"},
		{"  47"},
		{"  46"},
		{"  45"},
		{"  44"},
		{"  43"},
		{"  42"},
		{"  41"},
		{"  40"},
		{"  39"},
		{"  38"},
		{"  37"},
		{"  36"},
		{"  35"},
		{"  34"},
		{"  33"},
		{"  32"},
		{"  31"},
		{"  30"},
		{"  29"},
		{"  28"},
		{"  27"},
		{"  26"},
		{"  25"},
		{"  24"},
		{"  23"},
		{"  22"},
		{"  21"},
		{"  20"},
		{"  19"},
		{"  18"},
		{"  17"},
		{"  16"},
		{"  15"},
		{"  14"},
		{"  13"},
		{"  12"},
		{"  11"},
		{"  10"},
		{"   9"},
		{"   8"},
		{"   7"},
		{"   6"},
		{"   5"},
		{"   4"},
		{"   3"},
		{"   2"},
		{"   1"},
		{"  "},
	};
	static const char shuffle_menu[][8] = {
		{" Ȃ"},
		{"   "},
	};
	static const char mondai_menu[][8] = {
		{" ⁨"},
		{"   "},
		{" "},
	};
	static const char jis2_menu[][8] = {
		{" ̫"},
		{" ؼ"},
	};

	/* j[ */
	initInputTable("ݒ");

	/* j[o^ 1 */
	id = entryItem(TITLES[0],(char*)num_menu,100);
	setItemListVal(id,100-file);
	setItemListToggle(id,0);

	/* j[o^ 2*/
	id = entryItem(TITLES[1],(char*)shuffle_menu,2);
	setItemListVal(id,shuffle);

	/* j[o^ 3*/
	id = entryItem(TITLES[2],(char*)mondai_menu,3);
	setItemListVal(id,qas);

	/* j[o^ 4*/
	id = entryItem(TITLES[3],(char*)num_menu,101);
	setItemListVal(id,100-write);
	setItemListToggle(id,0);

	/* j[o^ 5*/
	id = entryItem(TITLES[4],(char*)jis2_menu,2);
	setItemListVal(id,(jis2==0x98)&1);

	/* j[o^ 6*/
	id = entryItemMenu(TITLES[5],(int*)folder);

	/* j[Jn */
	ret = runInputProc();

	if (ret==1) {
		/* XV */
		file=100-getItemListVal(getItemId(TITLES[0]));
		shuffle=getItemListVal(getItemId(TITLES[1]));
		qas=getItemListVal(getItemId(TITLES[2]));
		write=100-getItemListVal(getItemId(TITLES[3]));
		jis2=0xff-getItemListVal(getItemId(TITLES[4]))*(0xff-0x98);

		if(shuffle!=oldsh || file!=oldfile) {
			seed=(Time.NOW_Hour*3600)+(Time.NOW_Sec*60)+Time.NOW_Min;
			p=qa=0;
		}
		load_file();
		if(write) {
			spnum(s,write,3);
			dos_chdir(work);
			fp1=dos_crnew(s,0);
			dos_close(fp1);
		}
	}

	/* YȂ悤ɂĂ */
	endInputTable();

	/* ߂l -1:AvIv ȊO:I */
	return ret;
}

void qa_exit(int x)
{
	UINT fp1,wd[8];

	dispWaiting();
	if(fp0!=-1) {
		dos_close(fp0);
	}
	fp1=dos_create(INI,0x20);
	if(fp1!=-1) {
		wd[0]=file;
		wd[1]=p;
		if(shuffle) {
			wd[2]=seed;
		}
		else {
			wd[2]=0;
		}
		wd[3]=qas;
		if(jis2==0x98) {
			wd[3]+=0x100;
		}
		wd[4]=max2;
		wd[5]=max-max2;
		wd[6]=write;
		wd[7]=0;	/* reserved */
		dos_write(fp1,work,0x20);
		dos_write(fp1,(char *)wd,0x10);
		if(wd[5]) {
			dos_write(fp1,(char *)&six[wd[4]],wd[5]<<1);
		}
		dos_close(fp1);
		bi_vwrflush();
	}
	endWaiting();
	dos_exit(x);
}

/*-----------------------------------------------------------*/
/*	 C					      							 */
/*-----------------------------------------------------------*/
int main(void)
{
	int menuEND = 0;
	int bt;
	int ret;

	char *q,*a;
	int size;
	UINT fp1,wd[8],i;
	UCHAR s[5];
	UCHAR *add="001.QA";

	screen(1);						/*	̨Ӱ				*/
	gv_place(0,0);					/*	XYW@X:0, Y:0		*/

	work[0]=0;
	fp1=dos_open(INI,0);
	if(fp1!=-1) {
		size=dos_read(fp1,work,0x20);
		if(size==0x20) {
			size=dos_read(fp1,(char *)wd,0x10);
			if(size==0x10) {
				file=wd[0];
				p=wd[1];
				seed=wd[2];
				qas=wd[3];
				if(wd[3]&0x100) {
					jis2=0x98;
				}
				write=wd[6];
				if(wd[5]) {
					size=dos_read(fp1,(char *)&six[wd[4]],wd[5]<<1);
				}
			}
		}
		if(dos_close(fp1)!=0 || size<0) {
			qa_exit(0);
		}
		if(seed) {
			shuffle=1;
		}
	}
	load_file();
	if(max==wd[4]) {
		max+=wd[5];
	}

	endWaiting();					/*	NҰ݂̒~	*/
	while(1){
		q=&buf[index[six[p]]];
		a=q;
		while(*a>0x0d) {
			a++;
		}
		while(*a==9) {
			a++;
		}
		if(qas==2) {
			q=a;
			a=&buf[index[six[p]]];
		}
		lcdfreeze(1);
		pSystemCtl->EventManager->eventReq |= EVENT_SEC;
									/*	PbKeyin甲ݒ  */
		if(qa!=1) {
			pv_clear((RECT *)&CLRLCD);	/* ʃNA */
			disp_mes(q,0);
			spnum(s,max-p,4);
			s[4]=0;
			gv_kput(2,53,s,11,1,0);
			dispWATCH(1);				/*	Sʕ\	*/
		}
		if(qa || qas==1) {
			disp_mes(a,26);
			qa=2;
		}
		lcdfreeze(0);

		while(1){
			bt = Keyin( 0,-1 );
/* Keyiñ{^ȊÕCxg */
			if( bt & EVENT_REQ ){
				/* Keyin1Hzɔď */
				if ((pSystemCtl->EventManager->eventReq & EVENT_SEC) && 
				    (pSystemCtl->EventManager->event    & EVENT_SEC)){
				    pSystemCtl->EventManager->event &= ~EVENT_SEC;
					/*	1Hz\	*/
					dispWATCH(0);
				}
			}
			ret = EventCall(bt);
			if(ret == -1) {
				/* عݏIv */
				pSystemCtl->EventManager->eventReq &= ~EVENT_SEC;
				/* PbKeyin甲ݒ */
				qa_exit(0);
			}
			else if( ret == 1 ) {
				pSystemCtl->EventManager->eventReq &= ~EVENT_SEC;
										/*PbKeyin甲ݒ*/
				ret = EventExec();
				if (ret == -1) {
					/* عݏIv */
					qa_exit(0);
				}
				break;
			}
/* ܂ */
/* {^̃Cxg */
			if( bt&Key_menu ){
				pSystemCtl->EventManager->eventReq &= ~EVENT_SEC;
										/*PbKeyin甲ݒ*/
				if( CheckVol() ){/* dדd */
					dispVOLerr();	/* װ\ */
					qa_exit(0);
				}
				menuEND = aprMenu("Q&A R.1",menuLIST,
									(int)sizeof(menuLIST)/sizeof(MENU));
				if( menuEND == -2 )	qa_exit(0);	/* ع݂̏I	*/
				break;
			}
			else if( bt&Key_enter) {
				if(qa) {
					if(write) {
						spnum(add,write,3);
						dispWaiting();
						fp1=dos_open(add,1);
						if(fp1!=-1) {
							dos_seek(fp1, 2, 0);
							q=&buf[index[six[p]]];
							for(i=0;q[i]>0x0d || q[i]==9;i++) {
							}
							dos_write(fp1,q,i);
							dos_write(fp1,"\r\n",2);
							dos_close(fp1);
							bi_vwrflush();
						}
						endWaiting();
					}
					else {
						if(max<MAX) {
							six[max++]=six[p];
						}
					}
				}
				bt=Key_up;
			}
			if( bt&Key_right || bt&Key_up) {
				if(qa) {
					qa=0;
					if(p<max-1 && max!=0) {
						p++;
					}
					else {
						pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
						ret=dispYNLarge("II","Ē킵܂H",0);
						if(ret!=1) {
							p=0;
							max=max2;
						}
						if(ret==-1) {
							qa_exit(0);
						}
					}
				}
				else {
					qa=1;
				}
				break;
			}
			else if( bt&Key_left || bt&Key_down) {
				if(qa && qas!=1) {
					qa=0;
				}
				else {
					if(p>0) {
						p--;
					}
				}
				break;
			}
		}
	}
}
/* ܂ */

